# vim:set ts=2 sw=2 sts=2 et:
from rzn.api import obj

def __centroid(objs):
  cx = cy = 0
  for o in objs:
    cx += o.pos[0]
    cy += o.pos[1]
  return int(cx/float(len(objs))), int(cy/float(len(objs)))

def valign():
  """ Align selected parts along a vertical line """
  view = ui.currentTab().currentView()
  sel = view.selection()
  parts = [o for o in sel if isinstance(o, obj.SubPart)]
  if len(parts):
    cx, cy = view.gridAlignPoint(__centroid(parts))
    for p in parts:
      x,y = p.pos
      p.pos = (cx, y)

def halign():
  """ Align selected parts along a horizontal line """
  view = ui.currentTab().currentView()
  sel = view.selection()
  parts = [o for o in sel if isinstance(o, obj.SubPart)]
  if len(parts):
    cx, cy = view.gridAlignPoint(__centroid(parts))
    for p in parts:
      x,y = p.pos
      p.pos = (x, cy)

