# vim:set ts=2 sw=2 sts=2 et:
from rzn.api import obj, Transform, units

def autolabel():
  """ Automatically add labelled wires to a part """
  v = ui.currentTab().currentView()
  p = ui.currentTab().project()
  for o in v.selection():
    if isinstance(o, obj.Symbol):
      # put a wire and a label on each pin
      for pos, conn in o.connectors():
        angle = int(round(conn.getCurrentTransform().angle()))
        tfm = Transform.ident().trans(*pos).rot(angle)
        p1 = tfm.point(units.inch(0.0), 0)
        p2 = tfm.point(units.inch(0.15), 0)
        p.schematic.wire(p1, p2)
        sangle = (180+angle)%360
        p.part(None, p2, "razen/lib-port", "label")[0].angle = sangle


