# vim:set ts=2 sw=2 sts=2 et:
import inspect
import types

def cmds():
  """ return a list of user command functions """
  r = []
  for d,v in globals().items():
    if isinstance(v, types.FunctionType):
      r.append(d)
  return " ".join(sorted(r))

def help(obj):
  """ return basic help on a command function """
  doc = (obj.__doc__ if obj.__doc__ else "")
  if isinstance(obj, (types.FunctionType, types.MethodType)):
    args, varargs, varkw, defaults = inspect.getargspec(obj)
    return "%s(%s) - %s" % (obj.__name__, ", ".join(args), doc.strip())
  else:
    return "%s - %s" % (obj.__name__, doc.strip())
