# vim:set ts=2 sw=2 sts=2 et:
from rzn.api import obj

def sfilter(fn=None, objtype=None):
  """ filter the selection using a predicate function or an object type """
  v = ui.currentTab().currentView()
  if fn is None:
    if objtype is None:
      return "Need fn or objtype"
    fn = lambda x: isinstance(x, objtype)
  v.select([o for o in v.selection() if fn(o)])
  return v.selection()

def selecttype(objtype):
  """ select all objects of a specified type """
  v = ui.currentTab().currentView()
  v.select(v.projectView().objs(objtype))

def aligntopads(mindist=100):
  """ align all traces very near footprints the correct pads """
  v = ui.currentTab().currentView()
  proj = ui.currentTab().project()

  import math
  def dist(a, b):
    return math.hypot(a[0]-b[0], a[1]-b[1])

  for o in v.selection():
    if isinstance(o, obj.Footprint):
      for pt in o.points():
        for t in proj.layout.findAtPoint(pt, obj.Trace):
          if 0 < dist(t.pta, pt) < mindist:
            t.pta = pt
          elif 0 < dist(t.ptb, pt) < mindist:
            t.ptb = pt
