""" 
Generate a Beaglebone cape board outline based on dimensions in:
http://beagleboard.org/static/beaglebone/latest/Docs/Hardware/BONE_SRM.pdf

Outline script was generated with board2script.py
"""

from rzn.api import Layers

def footprint(project, lib, part, angle, footpos, sympos):
  _,f = project.part(None, sympos, lib, part)
  f.angle = angle
  f.pos = footpos

def main(project):
  layout = project.layout
  # outline
  layout.arc((-368300,209550), (0,63500), (-63500,0), 0, Layers.Border)
  layout.arc((304800,-146050), (0,-127000), (127000,0), 0, Layers.Border)
  layout.arc((304800,146050), (127000,0), (0,127000), 0, Layers.Border)
  layout.line((-228600,-114300), (-374650,-114300), 0, Layers.Border)
  layout.line((-228600,63500), (-228600,-114300), 0, Layers.Border)
  layout.line((-368300,273050), (304800,273050), 0, Layers.Border)
  layout.line((-374650,-114300), (-374650,-273050), 0, Layers.Border)
  layout.line((-431800,209550), (-431800,63500), 0, Layers.Border)
  layout.line((-431800,63500), (-228600,63500), 0, Layers.Border)
  layout.line((304800,-273050), (-374650,-273050), 0, Layers.Border)
  layout.line((431800,-146050), (431800,146050), 0, Layers.Border)
  # drills
  layout.drill((-285750,-241300), 31750)
  layout.drill((-285750,241300), 31750)
  layout.drill((374650,-209550), 31750)
  layout.drill((374650,209550), 31750)
  # headers
  footprint(project, "razen/lib-conn-header", "header-23x2", 
            270, (44450, -241300), (0,0))
  footprint(project, "razen/lib-conn-header", "header-23x2", 
            270, (44450, 241300), (127000,0))
