from rzn.api import obj, Layers
import os

def layer2str(o):
  return "Layers."+Layers.names[o.layer]

def pos2str(p):
  return "(%d,%d)" % (p[0], p[1])

def main(project):
  calls = []
  for o in project.layout.objs():
    if isinstance(o, obj.Segment):
      calls.append("line(%s, %s, %d, %s)" % (pos2str(o.pta), pos2str(o.ptb),
                   o.width, layer2str(o)))
    elif isinstance(o, obj.Arc):
      calls.append("arc(%s, %s, %s, %d, %s)" % (pos2str(o.pos), pos2str(o.ofsa),
                   pos2str(o.ofsb), o.width, layer2str(o)))
    elif isinstance(o, obj.Drill):
      calls.append("drill(%s, %d)" % (pos2str(o.pos), o.diameter))
    else:
      # FIXME: implement other object types
      pass
  # generate script
  script = "from rzn.api import Layers\n\ndef main(project):\n"
  script += "  layout = project.layout\n"
  for c in sorted(calls):
    script += "  layout.%s\n" % c
  # write
  fn = project.filename()
  f = open("%s.py" % os.path.join(fn, os.path.basename(fn)), "w")
  f.write(script)
