# vim:set ts=2 sw=2 sts=2 et:
from .texttool import TextTool
import inspect
from rzn.core import cmds
from rzn.api.wrap import SelectionWrapper
from rzn.log import Logger
from rzn import Razen

log = Logger(__name__)

def make_env(ui):
  curtab = Razen.window().current_tab()
  return {
      "Razen" : Razen,
      "w" : Razen.window(),
      "u" : ui,
      "s" : SelectionWrapper(curtab.current_view().selection),
      "p" : curtab.project(),
      "t" : curtab,
  }


class ToolCmd(TextTool):
  name = "Cmd"

  def __init__(self, tools):
    TextTool.__init__(self, tools)
    self.helptext = self.tr("Execute commands against the Python API")
    self.env = {}
    self.cmds = self.tools.get_cmds()

  def execute(self):
    cmd = self.text
    try:
      self.env.update(make_env(Razen.window().uiapi))
      self.env.update(self.cmds)
      r = cmds.evalcode(cmd, self.env)
    except Exception, exp:
      for frame, fn, ln, func, lnstr,_ in inspect.trace()[3:]:
        log.error('  File "%s", line %d, in %s' % (fn, ln, func))
        if lnstr:
          log.error('    %s' % "".join((x.strip() for x in lnstr)))
      r = "error: %s" % exp
    return repr(r)
