# vim:set ts=2 sw=2 sts=2 et:
from .tool import Tool
from rzn.obj.objs import SubPart, Airwire
import rzn

class ToolCopy(Tool):
  name = "Copy"

  def enter(self):
    design = self.view().design
    sel = list(self.view().selection.all())
    items = []
    for s in sel:
      if isinstance(s, SubPart):
        o = s.other()
        if o:
          items.append((design.other(), o._toJson()))
      if not isinstance(s, Airwire):
        items.append((design, s._toJson()))

    rzn.Razen.window().clipboard.setAll(items, self.view().abs_pos_grid())
    self.tools.switchtool("Select")
  
  def valid_for(self, view, part):
    return False
