# vim:set ts=2 sw=2 sts=2 et:
from .conntool import ConnTool
from rzn.obj.objs import Drill
from . import options

class ToolDrill(ConnTool):
  name = "Drill"
  
  def __init__(self, tools):
    ConnTool.__init__(self, tools)
    self.helptext = self.tr("Create a drill hole")
    self.add_option("Diameter", options.Dimension(self, defaultidx=3, 
                                        helptext=self.tr("Set drill diameter")))

  def _mkconn(self, ghost=False):
    view = self.view()
    pt = view.abs_pos_grid()
    return view.design.make_obj(Drill, view.design, pt, 
                                self.get_option("Diameter"), ghost=ghost)
  
  def option_changed(self, optname, value):
    ConnTool.option_changed(self, optname, value)
    if self.ghost:
      self.ghost.delete()
      self.ghost = self._mkconn(True)
  
  def valid_for(self, view, part):
    return view == "layout"
