# vim:set ts=2 sw=2 sts=2 et:
from .texttool import TextTool
import fnmatch

class ToolFind(TextTool):
  name = "Find"

  def __init__(self, tools):
    TextTool.__init__(self, tools)

  def _parse_search(self):
    if self.text.startswith("~"):
      return self.text[1:], True
    elif self.text.startswith("@"):
      return self.text[1:], False
    else:
      return fnmatch.translate(self.text), True

  def execute(self):
    sstr,re = self._parse_search()
    try:
      objs = self.view().design.findName(sstr, regexp=re)
      self.view().selectObjects(objs)
      self.view().zoomToObjects(objs)
      resp = self.tr("%d objects selected") % len(objs)
    except Exception as e:
      resp = self.tr("Invalid find string: %s") % str(e)
    return resp

