# vim:set ts=2 sw=2 sts=2 et:
from rzn.api import obj, Plugin
from collections import defaultdict
import csv
import os

class BOMCSVExportPlugin(Plugin):
  def __init__(self):
    Plugin.__init__(self, "BOM (CSV)", Plugin.EXPORT)

  def main(self, ui):
    self.batchMain(ui.currentTab().project(), {})

  def batchMain(self, proj, options):
    bom = defaultdict(list)
    for o in proj.schematic.objs(obj.Symbol):
      if o.other() and o.bom != "IGNORE":
        bom[(o.lib, o.part, o.value, o.bom)].append(o.name)

    bomfn = "%s.csv" % os.path.basename(proj.filename())
    fn = os.path.join(proj.filename(), bomfn)
    csvf = csv.writer(file(fn, "wb"))
    csvf.writerow(["Qty", "Part", "Library", "Value", "Ref", "Names"])
    for k in sorted(bom):
      lib, part, value, ref = k
      names = sorted(bom[k])
      qty = len(names)
      csvf.writerow([qty, part, lib, value, ref, ", ".join(names)])
