# vim:set ts=2 sw=2 sts=2 et:

def bezier(p0, p1, p2, p3, n):
  def bezier_point(t):
    u = 1 - t
    # 1st term
    px, py = (u**3)*p0[0], (u**3)*p0[1]
    # 2nd term
    px += 3*u*u*t*p1[0]
    py += 3*u*u*t*p1[1]
    # 3rd term
    px += 3*u*t*t*p2[0]
    py += 3*u*t*t*p2[1]
    # 4th term
    px += (t**3)*p3[0]
    py += (t**3)*p3[1]
    return px, py

  pts = []
  for i in range(n+1):
    t = i / float(n)
    pts.extend(bezier_point(t))
  return pts

