# vim:set ts=2 sw=2 sts=2 et:
import ConfigParser
import os

def read(basedir, section, option):
  hgrc = os.path.join(basedir, ".hg", "hgrc")
  if os.path.exists(hgrc):
    try:
      config = ConfigParser.ConfigParser()
      config.read(hgrc)
      return config.get(section, option)
    except Exception:
      pass
  return None

def write(basedir, section, option, value):
  hgrc = os.path.join(basedir, ".hg", "hgrc")
  config = ConfigParser.ConfigParser()
  if os.path.exists(hgrc):
    config.read(hgrc)
  if not config.has_section(section):
    config.add_section(section)
  config.set(section, option, value)
  config.write(open(hgrc,"w"))

